package hw4;

import futils.Futil;
import gui.In;
import gui.run.RunMenu;
import gui.run.RunMenuBar;
import gui.run.RunMenuItem;
import gui.run.RunJob;
import net.stocks.Quote;

import javax.swing.*;
import java.awt.*;
import java.util.Vector;


public class Hw4Quotes extends
        gui.ClosableJFrame {
    Vector quotes = new Vector();
    JLabel labels[];

    public void init() {
        Container c = getContentPane();
        c.add(setJMenuBar());
        getQuotes();
        setBackground(Color.white);
        labels = new JLabel[quotes.size()];
        for (int i = 0; i < quotes.size(); i++) {
            String s =
                    (String) quotes.elementAt(i);
            quoteLineToStringVector(s);
            labels[i] = new JLabel(s);
            addComponent(labels[i]);
        }
        setContainerLayout(new GridLayout(0, 1));
        pack();
        setVisible(true);
    }

    private RunMenuBar setJMenuBar() {
        RunMenuBar mb = new RunMenuBar();
        mb.add(getFileMenu());
        return mb;
    }

    public static RunMenu getFileMenu() {
        RunMenu fileMenu = new RunMenu("[File");
        fileMenu.add(new RunMenuItem("[close{alt shift Y}") {
            public void run() {
                System.out.println(getText());
            }
        });
        fileMenu.add(new RunMenuItem("[open{alt shift X}") {
            public void run() {
                System.out.println(Futil.getReadFileDir("select a directory"));
            }
        });
        fileMenu.add(new RunMenuItem("[quit{control q}") {
            public void run() {
                System.exit(0);
            }
        });
        fileMenu.add(new RunMenuItem("[save{alt control DELETE}") {
            public void run() {
                System.out.println(getText());
            }
        });
        return fileMenu;
    }

    public String[] quoteLineToStringVector(String pcs) {
        Vector stringVector =
                new Vector();
        String s = new String(pcs);
        //separate the strings delimited by commas
        for (
                int i = s.indexOf(',');
                i >= 0;
                i = s.indexOf(',')) {
            stringVector.addElement(s.substring(0, i));
            s = new String(s.substring(i + 1));
        }
        // add the last String left
        stringVector.addElement(s);
        String sa[] =
                new String[stringVector.size()];
        for (int i = 0; i < sa.length; i++)
            sa[i] = (String) stringVector.elementAt(i);
        return sa;
    }

    public void println(String s[]) {
        for (int i = 0; i < s.length; i++)
            System.out.println(s[i]);
    }

    public void print(String s[]) {
        for (int i = 0; i < s.length; i++)
            System.out.print(s[i] + ' ');
        System.out.println();
    }

    public void updateDisplay() {
        getQuotes();
        for (int i = 0; i < quotes.size(); i++) {
            labels[i].setText(
                    (String) quotes.elementAt(i));
        }
    }

    public void paint(Graphics g) {
        new RunJob(2,false){
            public void run(){
                updateDisplay();
            }
        };
        super.paint(g);
    }


    public Vector getQuotes() {
        Vector s = new Vector();
        s.addElement("aapl");
        s.addElement("open");
        s.addElement("xlnx");
        s.addElement("altr");
        s.addElement("mot");
        s.addElement("cy");
        s.addElement("crus");
        s.addElement("sfa");
        s.addElement("adbe");
        s.addElement("msft");
        s.addElement("sunw");
        s.addElement("lxk");
        s.addElement("AMZn");
        s.addElement("NT");
        return quotes =
                Quote.getUrl(
                        Quote.makeQuoteURLString(s));
    }

    public static void main(String args[]) {
        Hw4Quotes qf = new Hw4Quotes();
        qf.init();
    }

}